/*****************************************************************************
* Requests for /corpora routes                                               *
*****************************************************************************/
Requests.corpora = {};

Requests.corpora.entity = {};

Requests.corpora.entity.delete = (corpusId) => {
  let input = `/corpora/${corpusId}`;
  let init = {
    method: 'DELETE'
  };
  return Requests.JSONfetch(input, init);
};

Requests.corpora.entity.build = (corpusId) => {
  let input = `/corpora/${corpusId}/build`;
  let init = {
    method: 'POST',
  };
  return Requests.JSONfetch(input, init);
};

Requests.corpora.entity.generateShareLink = (corpusId, role, expiration) => {
  let input = `/corpora/${corpusId}/generate-share-link`;
  let init = {
    method: 'POST',
    body: JSON.stringify({role: role, expiration: expiration})
  };
  return Requests.JSONfetch(input, init);
};

Requests.corpora.entity.getStopwords = () => {
  let input = `/corpora/stopwords`;
  let init = {
    method: 'GET'
  };
  return Requests.JSONfetch(input, init);
};

Requests.corpora.entity.isPublic = {};

Requests.corpora.entity.isPublic.update = (corpusId, isPublic) => {
  let input = `/corpora/${corpusId}/is_public`;
  let init = {
    method: 'PUT',
    body: JSON.stringify(isPublic)
  };
  return Requests.JSONfetch(input, init);
};


/*****************************************************************************
* Requests for /corpora/<entity>/files routes                                *
*****************************************************************************/
Requests.corpora.entity.files = {};

Requests.corpora.entity.files.ent = {};

Requests.corpora.entity.files.ent.delete = (corpusId, corpusFileId) => {
  let input = `/corpora/${corpusId}/files/${corpusFileId}`;
  let init = {
    method: 'DELETE',
  };
  return Requests.JSONfetch(input, init);
};


/*****************************************************************************
* Requests for /corpora/<entity>/followers routes                            *
*****************************************************************************/
Requests.corpora.entity.followers = {};

Requests.corpora.entity.followers.add = (corpusId, usernames) => {
  let input = `/corpora/${corpusId}/followers`;
  let init = {
    method: 'POST',
    body: JSON.stringify(usernames)
  };
  return Requests.JSONfetch(input, init);
};

Requests.corpora.entity.followers.entity = {};

Requests.corpora.entity.followers.entity.delete = (corpusId, followerId) => {
  let input = `/corpora/${corpusId}/followers/${followerId}`;
  let init = {
    method: 'DELETE',
  };
  return Requests.JSONfetch(input, init);
};

Requests.corpora.entity.followers.entity.role = {};

Requests.corpora.entity.followers.entity.role.update = (corpusId, followerId, value) => {
  let input = `/corpora/${corpusId}/followers/${followerId}/role`;
  let init = {
    method: 'PUT',
    body: JSON.stringify(value)
  };
  return Requests.JSONfetch(input, init);
};
